﻿using Syncfusion.Windows.PropertyGrid;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CustomPropertyEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            pgrid.SelectedObject = new Article();
            CustomEditor editor = new CustomEditor();
            editor.Editor = new ComboEditor();
            editor.Properties.Add("ArticleID");
            this.pgrid.CustomEditorCollection.Add(editor);
            pgrid.RefreshPropertygrid();
        }
    }
    class Article
    {
        public Article()
        {
            ID = 111;
            Code = "ETC";
            ArticleID = 90;
        }
        public int ID { get; set; }

        public string Code { get; set; }

        public int ArticleID { get; set; }
    }

   
  public class ComboEditor : ITypeEditor
    {
        public void Attach(PropertyViewItem property, PropertyItem info)
        {
            if (info.CanWrite)
            {
                var binding = new Binding("Value")
                {
                    Mode = BindingMode.TwoWay,
                    Source = info,
                    ValidatesOnExceptions = true,
                    ValidatesOnDataErrors = true
                };
                BindingOperations.SetBinding(comboEdit, ComboBox.SelectedItemProperty, binding);
            }
            else
            {
                var binding = new Binding("Value")
                {
                    Mode = BindingMode.OneWayToSource,
                    //Source = info, < br >
                    //ValidatesOnExceptions = true,
                    ValidatesOnDataErrors = true
                };
                BindingOperations.SetBinding(comboEdit, ComboBox.SelectedItemProperty, binding);
            }
        }
        public ComboBox comboEdit;
        public object Create(System.Reflection.PropertyInfo PropertyInfo)
        {
            comboEdit = new ComboBox();
            comboEdit.SelectedItem = "90";
            comboEdit.Items.Add("90");
            comboEdit.Items.Add("30");
            comboEdit.Items.Add("40");
            comboEdit.Items.Add("70");

            return comboEdit;
        }
        public void Detach(PropertyViewItem property)
        {
            throw new NotImplementedException();
        }
    }


}
